Subject: [PATCH] ARM: gta02: Add gpio bank B quirk for hardware revision 5 and earlier

From: [email-masked] (Jamie Lokier)
Date: Mon, 30 Nov 2009 18:56:13 +0000

Pavel Machek wrote:
> On Sun 2009-11-29 11:56:51, Lars-Peter Clausen wrote:
> > Pavel Machek wrote:
> > > Hi!
> > >
> > >> On gta02 hardware revision 5 and earlier the basis resistors for
> > >> transistors of the leds are missing and reading their gpio pin
> > >> status will always return 0. So we have to shadow the led states
> > >> in software. This is done by "hijacking" the gpio accessor
> > >> functions for bank B.
> > >
> > > Should that be done in LED driver, instead? Pave
> > Hi
> > 
> > Nope, that won't work. Every time a gpio on gpb is changed the leds
> > will turn off. So we would have to ship a special version of each
> > driver using a gpio pin form gpb. We certainly don't want to do that.
> 
> _Any_ GPIO pin change will turn off the LED? Wow, the hardware is
> severely misdesigned then, ok. That means you do need to modify GPIO
> :-(. You probably should state it clearly in the comments.

I don't think it's necessarily a hardware misdesign if you can't read
back the value of output-only GPIOs, even though it's inconvenient.
But from the sound of that comment, I'd worry about the current consumed :-)

-- Jamie